<?php
add_theme_support( 'post-thumbnails' );

if (get_option('storefront_shorten_product_descriptions' ) =='true' ) {
	add_action ('wp_head','shorten_product_description');  //put the query in the header
	
	function shorten_product_description () {
	?>
	
		<style>
		div.default_product_display .additional_description_span,
		div.default_product_display form.product_form .custom_meta,
		div.default_product_display form.product_form .wpsc_variation_forms,
		div.default_product_display form.product_form .wpsc_extras_forms/*,
		div.default_product_display input.wpsc_buy_button*/
		  {display:none;}
		</style>
	
	     <script type="text/javascript">
	          function shorten(sometext,maxlen) { return ((sometext.length<=maxlen)?sometext:(sometext.substr(0,maxlen-3)+"...")); }
	     </script>
	
	     <script type="text/javascript">
	     jQuery(document).ready( function () {
	
	          jQuery('.default_product_display .wpsc_description').each(function(index){ //gets the link in all teaser headlines
	                var t = jQuery(this).text();
	                jQuery(this).text(shorten(t,200)); //truncate to 200
	          });
	     });
	    </script>
	<?php
	}
}
add_action ('wp_head','shorten_gridview_title');  //put the query in the header
	
	function shorten_gridview_title () {
	?>
	
	     <script type="text/javascript">
	          function shorten(sometext,maxlen) { return ((sometext.length<=maxlen)?sometext:(sometext.substr(0,maxlen-3)+"...")); }
	     </script>
	
	     <script type="text/javascript">
	     jQuery(document).ready( function () {
	
	          jQuery('.prodgridviewname,.category_gridentry_title ').each(function(index){ //gets the link in all teaser headlines
	                var t = jQuery(this).text();
	                jQuery(this).text(shorten(t,25)); //truncate to 200
	          });
	     });
	    </script>
	<?php
	}

/*
===============================================================
Custom Post Type For Slider
===============================================================
*/

		add_action('init', 'create_slider_post_type');
	
		function create_slider_post_type() {
	    	$args = array(
	        	'label' => __('Slider'),
	        	'singular_label' => __('Slide'),
	        	'public' => true,
	        	'show_ui' => true,
	        	'capability_type' => 'post',
	        	'hierarchical' => false,
	        	'rewrite' => true,
        		'labels' => array(
					'name' => __( 'Slider' ),
					'singular_name' => __( 'Slide' ),
					'add_new' => __( 'Add New' ),
					'add_new_item' => __( 'Add New Slide' ),
					'edit' => __( 'Edit' ),
					'edit_item' => __( 'Edit Slide' ),
					'new_item' => __( 'New Slide' ),
					'view' => __( 'View Slide' ),
					'view_item' => __( 'View Slide' ),
					'search_items' => __( 'Search Slides' ),
					'not_found' => __( 'No slides found' ),
					'not_found_in_trash' => __( 'No slides found in Trash' ),
					'parent' => __( 'Parent Slide' ),
				),
	        	'supports' => array('title', 'thumbnail')
	        );
	
	    	register_post_type( 'slide' , $args );
	
	?>
<?php
/*
===============================================================
Icon For Slider
===============================================================
*/
add_action( 'admin_head', 'my_custom_posttype_icon' );
function my_custom_posttype_icon() {
    ?>
    <style type="text/css" media="screen">
    /*<![CDATA[*/
        #menu-posts-slide .wp-menu-image {
            background: url("<?php bloginfo( 'template_url' );?>/images/slider-menu-icon.png") no-repeat 0px -33px !important;
        }
                #menu-posts-slide:hover .wp-menu-image, #menu-posts-slide.wp-has-current-submenu .wp-menu-image {
            background: url("<?php bloginfo( 'template_url' );?>/images/slider-menu-icon.png") no-repeat 0px -1px !important;
        }
    /*]]>*/
    </style>
    <?php
}


/*
===============================================================
Options For Slider
===============================================================
*/
	
		add_action("admin_init", "admin_init");
		add_action('save_post', 'save_slide_meta');
	
		function admin_init(){
			add_meta_box("slider-meta", "Slider Options", "meta_options", "slide", "normal", "low");
		}
	
		function meta_options(){
			global $post;
			$custom = get_post_custom($post->ID);
			$text = $custom["text"][0];
			$link = $custom["link"][0];
	?>
	<p>Set a featured image for this slide using the built-in WordPress featured image feature which is normally located on the right hand side of this page.  </p><p>Then, enter a url (beginning with "http://") of a page, post, product, category or even an off-site link using the field below.</p><br />
		<label style="width:80px;float:left;display:block;font-weight:bold;padding:5px;">Link URL:</label><input style="width:300px;border:1px solid #ccc;" name="link" value="<?php echo $link; ?>" />
	<?php
		}
	
	function save_slide_meta(){
		global $post;
		update_post_meta($post->ID, "text", $_POST["text"]);
		update_post_meta($post->ID, "link", $_POST["link"]);
	}
} //END OF CHECK FOR CUSTOM POST TYPE


//////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*
===============================================================
Custom Post Type For Carousel
===============================================================
*/

		add_action('init', 'create_carousel_post_type');
	
		function create_carousel_post_type() {
	    	$args = array(
	        	'label' => __('Carousel'),
	        	'singular_label' => __('carousel'),
	        	'public' => true,
	        	'show_ui' => true,
	        	'capability_type' => 'post',
	        	'hierarchical' => false,
	        	'rewrite' => true,
	        	'labels' => array(
					'name' => __( 'Carousel' ),
					'singular_name' => __( 'Carousel Item' ),
					'add_new' => __( 'Add New' ),
					'add_new_item' => __( 'Add New Carousel Item' ),
					'edit' => __( 'Edit' ),
					'edit_item' => __( 'Edit Carousel Item' ),
					'new_item' => __( 'New Carousel Item' ),
					'view' => __( 'View Carousel Item' ),
					'view_item' => __( 'View Carousel Item' ),
					'search_items' => __( 'Search Carousel Items' ),
					'not_found' => __( 'No carousel items found' ),
					'not_found_in_trash' => __( 'No carousel items found in Trash' ),
					'parent' => __( 'Parent Carousel Item' ),
				),
	        	'supports' => array('title', 'thumbnail')
	        );
	
	    	register_post_type( 'carousel' , $args );
	
	?>
<?php
/*
===============================================================
Icon For Carousel
===============================================================
*/
add_action( 'admin_head', 'carousel_posttype_icon' );
function carousel_posttype_icon() {
    ?>
    <style type="text/css" media="screen">
    /*<![CDATA[*/
        #menu-posts-carousel .wp-menu-image {
            background: url("<?php bloginfo( 'template_url' );?>/images/carousel-menu-icon.png") no-repeat 0px -33px !important;
        }
                #menu-posts-carousel:hover .wp-menu-image, #menu-posts-carousel.wp-has-current-submenu .wp-menu-image {
            background: url("<?php bloginfo( 'template_url' );?>/images/carousel-menu-icon.png") no-repeat 0px -1px !important;
        }
    /*]]>*/
    </style>
    <?php
}


/*
===============================================================
Options For Carousel
===============================================================
*/
	
		add_action("admin_init", "admin_init_carousel");
		add_action('save_post', 'save_carousel_meta');
	
		function admin_init_carousel(){
			add_meta_box("carousel-meta", "Carousel Options", "meta_options_carousel", "carousel", "normal", "low");
		}
	
		function meta_options_carousel(){
			global $post;
			$custom = get_post_custom($post->ID);
			$text = $custom["text"][0];
			$link = $custom["link"][0];
	?>
	<p>Set a featured image for this carousel item using the built-in WordPress featured image feature which is normally located on the right hand side of this page.  </p><p>Then, enter a url (beginning with "http://") of a page, post, product, category or even an off-site link using the field below.</p><br />
		<label style="width:80px;float:left;display:block;font-weight:bold;padding:5px;">Link URL:</label><input style="width:300px;border:1px solid #ccc;" name="link" value="<?php echo $link; ?>" />
	<?php
		}
	
	function save_carousel_meta(){
		global $post;
		update_post_meta($post->ID, "text", $_POST["text"]);
		update_post_meta($post->ID, "link", $_POST["link"]);
	}
} //END OF CHECK FOR CUSTOM POST TYPE CAROUSEL


//////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*
===============================================================
Custom Post Type For Gridview
===============================================================
*/

		add_action('init', 'create_gridview_post_type');
	
		function create_gridview_post_type() {
	    	$args = array(
	        	'label' => __('Gridview'),
	        	'singular_label' => __('gridview'),
	        	'public' => true,
	        	'show_ui' => true,
	        	'capability_type' => 'post',
	        	'hierarchical' => false,
	        	'rewrite' => true,
	        	'labels' => array(
					'name' => __( 'Gridview' ),
					'singular_name' => __( 'Gridview Item' ),
					'add_new' => __( 'Add New' ),
					'add_new_item' => __( 'Add New Gridview Item' ),
					'edit' => __( 'Edit' ),
					'edit_item' => __( 'Edit Gridview Item' ),
					'new_item' => __( 'New Gridview Item' ),
					'view' => __( 'View Gridview Item' ),
					'view_item' => __( 'View Gridview Item' ),
					'search_items' => __( 'Search Gridview Items' ),
					'not_found' => __( 'No gridview items found' ),
					'not_found_in_trash' => __( 'No gridview items found in Trash' ),
					'parent' => __( 'Parent Gridview Item' ),
				),
	        	'supports' => array('title', 'thumbnail')
	        );
	
	    	register_post_type( 'gridview' , $args );
	
	?>
<?php
/*
===============================================================
Icon For Gridview
===============================================================
*/
add_action( 'admin_head', 'gridview_posttype_icon' );
function gridview_posttype_icon() {
    ?>
    <style type="text/css" media="screen">
    /*<![CDATA[*/
        #menu-posts-gridview .wp-menu-image {
            background: url("<?php bloginfo( 'template_url' );?>/images/gridview-menu-icon.png") no-repeat 0px -33px !important;
        }
                #menu-posts-gridview:hover .wp-menu-image, #menu-posts-gridview.wp-has-current-submenu .wp-menu-image {
            background: url("<?php bloginfo( 'template_url' );?>/images/gridview-menu-icon.png") no-repeat 0px -1px !important;
        }
    /*]]>*/
    </style>
    <?php
}


/*
===============================================================
Options For Gridview
===============================================================
*/
	
		add_action("admin_init", "admin_init_gridview");
		add_action('save_post', 'save_gridview_meta');
	
		function admin_init_gridview(){
			add_meta_box("gridview-meta", "Gridview Options", "meta_options_gridview", "gridview", "normal", "low");
		}
	
		function meta_options_gridview(){
			global $post;
			$custom = get_post_custom($post->ID);
			$text = $custom["text"][0];
			$link = $custom["link"][0];
	?>
	<p>Set a featured image for this gridview item using the built-in WordPress featured image feature which is normally located on the right hand side of this page.</p><p>Then, enter a url (beginning with "http://") of a page, post, product, category or even an off-site link using the field below.</p><br />
		<label style="width:80px;float:left;display:block;font-weight:bold;padding:5px;">Link URL:</label><input style="width:300px;border:1px solid #ccc;" name="link" value="<?php echo $link; ?>" />
	<?php
		}
	
	function save_gridview_meta(){
		global $post;
		update_post_meta($post->ID, "text", $_POST["text"]);
		update_post_meta($post->ID, "link", $_POST["link"]);
	}
} //END OF CHECK FOR CUSTOM POST TYPE GRIDVIEW




/*
 * Resize images dynamically using wp built in functions
 * Victor Teixeira
 *
 * php 5.2+
 *
 * Exemplo de uso:
 * 
 * <?php 
 * $thumb = get_post_thumbnail_id(); 
 * $image = vt_resize( $thumb, '', 140, 110, true );
 * ?>
 * <img src="<?php echo $image[url]; ?>" width="<?php echo $image[width]; ?>" height="<?php echo $image[height]; ?>" />
 *
 * @param int $attach_id
 * @param string $img_url
 * @param int $width
 * @param int $height
 * @param bool $crop
 * @return array
 */
function vt_resize( $attach_id = null, $img_url = null, $width, $height, $crop = false ) {

	// this is an attachment, so we have the ID
	if ( $attach_id ) {
	
		$image_src = wp_get_attachment_image_src( $attach_id, 'full' );
		$file_path = get_attached_file( $attach_id );
	
	// this is not an attachment, let's use the image url
	} else if ( $img_url ) {
		
		$file_path = parse_url( $img_url );
		$file_path = $_SERVER['DOCUMENT_ROOT'] . $file_path['path'];
		
		//$file_path = ltrim( $file_path['path'], '/' );
		//$file_path = rtrim( ABSPATH, '/' ).$file_path['path'];
		
		$orig_size = getimagesize( $file_path );
		
		$image_src[0] = $img_url;
		$image_src[1] = $orig_size[0];
		$image_src[2] = $orig_size[1];
	}
	
	$file_info = pathinfo( $file_path );
	$extension = '.'. $file_info['extension'];

	// the image path without the extension
	$no_ext_path = $file_info['dirname'].'/'.$file_info['filename'];

	$cropped_img_path = $no_ext_path.'-'.$width.'x'.$height.$extension;

	// checking if the file size is larger than the target size
	// if it is smaller or the same size, stop right here and return
	if ( $image_src[1] > $width || $image_src[2] > $height ) {

		// the file is larger, check if the resized version already exists (for $crop = true but will also work for $crop = false if the sizes match)
		if ( file_exists( $cropped_img_path ) ) {

			$cropped_img_url = str_replace( basename( $image_src[0] ), basename( $cropped_img_path ), $image_src[0] );
			
			$vt_image = array (
				'url' => $cropped_img_url,
				'width' => $width,
				'height' => $height
			);
			
			return $vt_image;
		}

		// $crop = false
		if ( $crop == false ) {
		
			// calculate the size proportionaly
			$proportional_size = wp_constrain_dimensions( $image_src[1], $image_src[2], $width, $height );
			$resized_img_path = $no_ext_path.'-'.$proportional_size[0].'x'.$proportional_size[1].$extension;			

			// checking if the file already exists
			if ( file_exists( $resized_img_path ) ) {
			
				$resized_img_url = str_replace( basename( $image_src[0] ), basename( $resized_img_path ), $image_src[0] );

				$vt_image = array (
					'url' => $resized_img_url,
					'width' => $proportional_size[0],
					'height' => $proportional_size[1]
				);
				
				return $vt_image;
			}
		}

		// no cache files - let's finally resize it
		$new_img_path = image_resize( $file_path, $width, $height, $crop );
		$new_img_size = getimagesize( $new_img_path );
		$new_img = str_replace( basename( $image_src[0] ), basename( $new_img_path ), $image_src[0] );

		// resized output
		$vt_image = array (
			'url' => $new_img,
			'width' => $new_img_size[0],
			'height' => $new_img_size[1]
		);
		
		return $vt_image;
	}

	// default output - without resizing
	$vt_image = array (
		'url' => $image_src[0],
		'width' => $image_src[1],
		'height' => $image_src[2]
	);
	
	return $vt_image;
}

?>