<?php 

/*-----------------------------------------------------------------------------------

TABLE OF CONTENTS

- Custom hook definitions
- Add specific IE styling/hacks to HEAD
- Add custom styling
- Include CSS file for selected layout in options panel
- storefrontSlider Setup
- storefrontSlider Magazine template
- Navigation
- Post More
- Video Embed
- storefront Conditionals
-----------------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------------*/
/* Custom Hook definition */
/*-----------------------------------------------------------------------------------*/

// Add any custom hook definitions you want here
// function storefront_hook_name() { do_action( 'storefront_hook_name' ); }	


/*-----------------------------------------------------------------------------------*/
/* Add specific IE styling/hacks to HEAD */
/*-----------------------------------------------------------------------------------*/

add_action('wp_head','storefront_IE_head');
function storefront_IE_head() {
?>

<!--[if IE 6]>
<script type="text/javascript" src="<?php bloginfo('template_directory'); ?>/includes/js/pngfix.js"></script>
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo('template_directory'); ?>/css/ie6.css" />
<![endif]-->	

<!--[if IE 7]>
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo('template_directory'); ?>/css/ie7.css" />
<![endif]-->

<!--[if IE 8]>
<link rel="stylesheet" type="text/css" media="all" href="<?php bloginfo('template_directory'); ?>/css/ie8.css" />
<![endif]-->

<?php
}

/*-----------------------------------------------------------------------------------*/
/* // Add custom styling */
/*-----------------------------------------------------------------------------------*/

add_action('wp_head','storefront_custom_styling');
function storefront_custom_styling() {

	global $storefront_options;
	$output = '';
		
	// Logo
	if ( !$storefront_options['storefront_logo'] )
		$output .= '#logo .site-title, #logo .site-description { display:block; }' . "\n";

	// Styling options output in header
	if ( $storefront_options['storefront_style_disable'] <> "true" && $storefront_options['storefront_alt_stylesheet'] == "default.css" ) :

		// Layout styling
		$bg = $storefront_options['storefront_style_bg'];
		$bg_image = $storefront_options['storefront_style_bg_image'];
		$bg_image_repeat = $storefront_options['storefront_style_bg_image_repeat'];
		$bg_image_position = $storefront_options['storefront_style_bg_image_position'];	
	
		$body = '';
		if ($bg)
			$body .= 'background-color:'.$bg.';';
		if ($bg_image)
			$body .= 'background-image:url('.$bg_image.');';
		if ($bg_image_repeat)
			$body .= 'background-repeat:'.$bg_image_repeat.';background-position:'.$bg_image_position.';';
		if ($border_top && $border_top['width'] >= 0)
			$body .= 'border-top:'.$border_top["width"].'px '.$border_top["style"].' '.$border_top["color"].';';
		if ( $body != '' )
			$output .= 'body {'. $body . '}'. "\n";
	
		// General styling
		$link = $storefront_options['storefront_link_color'];
		$hover = $storefront_options['storefront_link_hover_color'];
		$button = $storefront_options['storefront_button_color'];
	
		if ($link)
			$output .= 'a:link, a:visited {color:'.$link.'}' . "\n";
		if ($hover)
			$output .= 'a:hover {color:'.$hover.'}' . "\n";
		if ($button)
			$output .= '.button, .reply a {background-color:'.$button.'}' . "\n";

		/* General Typography		
		$font_logo = $storefront_options['storefront_font_logo'];	
		$font_desc = $storefront_options['storefront_font_desc'];	
		$font_text = $storefront_options['storefront_font_text'];	
		$font_h1 = $storefront_options['storefront_font_h1'];	
		$font_h2 = $storefront_options['storefront_font_h2'];	
		$font_h3 = $storefront_options['storefront_font_h3'];	
		$font_h4 = $storefront_options['storefront_font_h4'];	
		$font_h5 = $storefront_options['storefront_font_h5'];	
		$font_h6 = $storefront_options['storefront_font_h6'];	
	
		if ( $font_logo )
			$output .= '#logo .site-title a {font:'.$font_logo["style"].' '.$font_logo["size"].'px/1em '.stripslashes($font_logo["face"]).';color:'.$font_logo["color"].'}' . "\n";	
		if ( $font_desc )
			$output .= '#logo .site-description {font:'.$font_desc["style"].' '.$font_desc["size"].'px/1em '.stripslashes($font_desc["face"]).';color:'.$font_desc["color"].'}' . "\n";	
		if ( $font_text )
			$output .= 'body, p {font:'.$font_text["style"].' '.$font_text["size"].'px/1.5em '.stripslashes($font_text["face"]).';color:'.$font_text["color"].'}' . "\n";	
		if ( $font_h1 )
			$output .= 'h1 {font:'.$font_h1["style"].' '.$font_h1["size"].'px/1.5em '.stripslashes($font_h1["face"]).';color:'.$font_h1["color"].'}';	
		if ( $font_h2 )
			$output .= 'h2 {font:'.$font_h2["style"].' '.$font_h2["size"].'px/1.5em '.stripslashes($font_h2["face"]).';color:'.$font_h2["color"].'}';	
		if ( $font_h3 )
			$output .= 'h3 {font:'.$font_h3["style"].' '.$font_h3["size"].'px/1.5em '.stripslashes($font_h3["face"]).';color:'.$font_h3["color"].'}';	
		if ( $font_h4 )
			$output .= 'h4 {font:'.$font_h4["style"].' '.$font_h4["size"].'px/1.5em '.stripslashes($font_h4["face"]).';color:'.$font_h4["color"].'}';	
		if ( $font_h5 )
			$output .= 'h5 {font:'.$font_h5["style"].' '.$font_h5["size"].'px/1.5em '.stripslashes($font_h5["face"]).';color:'.$font_h5["color"].'}';	
		if ( $font_h6 )
			$output .= 'h6 {font:'.$font_h6["style"].' '.$font_h6["size"].'px/1.5em '.stripslashes($font_h6["face"]).';color:'.$font_h6["color"].'}' . "\n";
			*/
			
		// Boxed styling
		$boxed = $storefront_options['storefront_layout_boxed'];
		$box_bg = $storefront_options['storefront_style_box_bg'];
		$box_border_radius = $storefront_options['storefront_box_border_radius'];
		$box_shadow = $storefront_options['storefront_box_shadow'];
	
		$wrapper = '';
		
			//$wrapper .= 'margin:0 auto;padding:0 0 20px 0;width:'.$storefront_options['storefront_layout_width'].';';

		if ($box_bg)
			$wrapper .= 'background-color:'.$box_bg.';';
			
		if ($box_border_radius )
			$wrapper .= 'border-radius:'.$box_border_radius.';-moz-border-radius:'.$box_border_radius.';-webkit-border-radius:'.$box_border_radius.';';
			
		if ($box_shadow == "true" )
			$wrapper .= 'box-shadow: 0px 1px 5px rgba(0,0,0,.3);-moz-box-shadow: 0px 1px 5px rgba(0,0,0,.3);-webkit-box-shadow: 0px 1px 5px rgba(0,0,0,.3);';
	
		if ( $wrapper != '' )
			$output .= '.generalbox {'. $wrapper . '}'. "\n";	
	
//END OF CUSTOM STYLING	
	endif;
	
	// Output styles
	if (isset($output)) {
		$output = "\n<!-- storefront Custom Styling -->\n<style type=\"text/css\">\n" . $output . "</style>\n<!-- /storefront Custom Styling -->\n\n";
		echo $output;
	}
		
} 

/*-----------------------------------------------------------------------------------*/
/* Post More  */
/*-----------------------------------------------------------------------------------*/

function storefront_post_more() { 
?>
	<div class="post-more">       
		<span class="read-more"><a href="<?php the_permalink() ?>" title="<?php _e('Read full story','storefrontthemes'); ?>"><?php _e('Read full story','storefrontthemes'); ?></a></span> &bull;             
		<span class="comments"><?php comments_popup_link(__('Comments { 0 }', 'storefrontthemes'), __('Comments { 1 }', 'storefrontthemes'), __('Comments { % }', 'storefrontthemes')); ?></span>
	</div>                        	
<?php
}


/*-----------------------------------------------------------------------------------*/
/* Video Embed  */
/*-----------------------------------------------------------------------------------*/
function canvas_get_embed() { 
	global $storefront_options;
	
	// Setup height & width of embed
	$width = "610";
	$height = "343";
	$layout = $storefront_options['storefront_layout'];
	$layout_width = $storefront_options['storefront_layout_width'];

	if ( $layout == "one-col" ) {

		if ( $layout_width == '980px' ) { 
			$width = "980";
		} elseif ( $layout_width == '960px' ) {
			$width = "960";
		} elseif ( $layout_width == '880px' ) {
			$width = "880";
		} elseif ( $layout_width == '760px' ) {
			$width = "760";
		} else {
			$width = "940";
		}

	} elseif ( $layout == "two-col-left" || $layout == "two-col-right" || $layout == "two-col-middle" ) {

		if ( $layout_width == '980px' ) { 
			$width = "650";
			$height = "365";
		} elseif ( $layout_width == '960px' ) {
			$width = "630";
			$height = "354";
		} elseif ( $layout_width == '880px' ) {
			$width = "550";
			$height = "309";
		} elseif ( $layout_width == '760px' ) {
			$width = "480";
			$height = "270";
		} else {
			$width = "610";
		}

	} elseif ( $layout == "three-col-left" || $layout == "three-col-right" || $layout == "three-col-middle" ) {

		if ( $layout_width == '980px' ) { 
			$width = "480";
			$height = "270";
		} elseif ( $layout_width == '960px' ) {
			$width = "460";
			$height = "259";
		} elseif ( $layout_width == '880px' ) {
			$width = "420";
			$height = "236";
		} elseif ( $layout_width == '760px' ) {
			$width = "350";
			$height = "197";
		} else {
			$width = "440";
			$height = "247";
		}

	} 

	if ( storefront_embed('') ) {
?>

<div class="post-embed">
	<?php echo storefront_embed('width='.$width.'&height='.$height); ?>
</div><!-- /.post-embed -->

<?php 
	}
} 


/*-----------------------------------------------------------------------------------*/
/* storefront Conditionals */
/*-----------------------------------------------------------------------------------*/

add_action('storefront_head', 'storefront_conditionals');
function storefront_conditionals() { 

	// Video Embed
	if( is_single() ) { 
		add_action('storefront_post_inside_before','canvas_get_embed');
	} 

	// Post More
	if ( !is_singular() || is_page_template('template-blog.php') || is_page_template('template-magazine.php')) {
		add_action('storefront_post_inside_after','storefront_post_more');					  
	}
}

/*-----------------------------------------------------------------------------------*/
/* storefront Replace Titles */
/*-----------------------------------------------------------------------------------*/

add_action('wp_head','storefront_replace_titles');
function storefront_replace_titles() {
	if (get_option('wpsc_replace_page_title') == 1) {
	echo '<style>
	.wpsc-single-product .productdisplay .producttext h2.prodtitles {display:none;}
	.productdisplay .producttext .wpsc_description {margin-top:0px;}
	h3.wpsc_category_boundary {display:none;}
	</style>';
	}
}
/*-----------------------------------------------------------------------------------*/
/* END */
/*-----------------------------------------------------------------------------------*/
?>