<?php
/*
==============================================================
Adapted from original code by WooThemes - http://woothemes.com
==============================================================
*/

function storefront_options(){
// VARIABLES
$themename = "Storefront Original";
$version = "2.2.2";
$manualurl = 'http://www.storefrontthemes.com';
$shortname = "storefront";

$GLOBALS['template_path'] = get_bloginfo('template_directory');

//Access the WordPress Categories via an Array
$storefront_categories = array();  
$storefront_categories_obj = get_categories('hide_empty=0');
foreach ($storefront_categories_obj as $storefront_cat) {
    $storefront_categories[$storefront_cat->cat_ID] = $storefront_cat->cat_name;}
$categories_tmp = array_unshift($storefront_categories, "Show All Posts");    
       
//Access the WordPress Pages via an Array
$storefront_pages = array();
$storefront_pages_obj = get_pages('sort_column=post_parent,menu_order');    
foreach ($storefront_pages_obj as $storefront_page) {
    $storefront_pages[$storefront_page->ID] = $storefront_page->post_name; }
$storefront_pages_tmp = array_unshift($storefront_pages, "Select a page:");      

//Access the WPEC Product Categories via an Array
$storefront_shop_categories = array();  
$storefront_shop_categories_obj = get_categories(array('hide_empty' => 0,'taxonomy' => 'wpsc_product_category'));
foreach ($storefront_shop_categories_obj as $storefront_shop_cat) {
    $storefront_shop_categories[$storefront_shop_cat->cat_ID] = $storefront_shop_cat->cat_name;}
$shop_categories_tmp = array_unshift($storefront_shop_categories, "Show All Products");  

//Testing 
$options_select = array("one","two","three","four","five"); 
$options_radio = array("one" => "One","two" => "Two","three" => "Three","four" => "Four","five" => "Five"); 

//Stylesheets Reader
$alt_stylesheet_path = TEMPLATEPATH . '/styles/';
$alt_stylesheets = array();

if ( is_dir($alt_stylesheet_path) ) {
    if ($alt_stylesheet_dir = opendir($alt_stylesheet_path) ) { 
        while ( ($alt_stylesheet_file = readdir($alt_stylesheet_dir)) !== false ) {
            if(stristr($alt_stylesheet_file, ".css") !== false) {
                $alt_stylesheets[] = $alt_stylesheet_file;
            }
        }    
    }
}

//Colorsheets Reader
$alt_colorsheet_path = TEMPLATEPATH . '/colors/';
$alt_colorsheets = array();

if ( is_dir($alt_colorsheet_path) ) {
    if ($alt_colorsheet_dir = opendir($alt_colorsheet_path) ) { 
        while ( ($alt_colorsheet_file = readdir($alt_colorsheet_dir)) !== false ) {
            if(stristr($alt_colorsheet_file, ".css") !== false) {
                $alt_colorsheets[] = $alt_colorsheet_file;
            }
        }    
    }
}

//More Options
$all_uploads_path = get_bloginfo('home') . '/wp-content/uploads/';
$all_uploads = get_option('storefront_uploads');
$other_entries = array("Select a number:","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19");
$numbers_only = array("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19");
$featured_speed = array("Select a number:","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19");
$featured_trans_speed = array("Select a number:","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","20","25","30");
$background_image_options = array("Center the image at the top of the page", "Tile the image", "Repeat horizontally across the top", "Repeat vertically down the left side" ,"Repeat vertically down the right side");

$meta_description_options = array("Product Description", "Product Additional Description", "Product Merchant Notes");
$meta_keyword_options = array("Product Description", "Product Additional Description", "Product Merchant Notes");

$homepage_carousel = array("Don't use the carousel div", "Show Product Categories", "Show Products", "Show Posts", "Show Carousel Post Type");
$homepage_gridview = array("Don't use the gridview div", "Show Product Categories", "Show Products", "Show Posts", "Show Gridview Post Type");
$featured_display_options = array("Show Blog Posts", "Use Slider Post Type (slide effect)", "Use Slider Post Type (fade effect)", "Use a Static Image", "Use Custom HTML");
$nav_right_side_options = array("Leave It Blank", "Show a Searchbox", "Show Feed Icons", "Show Product Category Dropbox");

$ad_template = "advertising";
$nav_template = "nav";
$image_template = "image";

$GLOBALS['template_path'] = get_bloginfo('template_directory');


// THESE ARE THE DIFFERENT FIELDS

/*
=================================
		General Settings
=================================
*/

$options = array();
$options[] = array(    "name" => "General Settings","class" => "settings",
                    "type" => "heading");
                    
$options[] = array(    "name" => "Display Message to IE6 Users?",
                                        "desc" => "If checked, this option will place a message to IE6 browsers just above the navigation bar encouraging them to upgrade to utilize the full features of the site.",
                                        "id" => $shortname."_show_ie6_message",
                                        "std" => "false",
                                        "type" => "checkbox");
                    
$options[] = array(    "name" => "Custom Logo",
                                        "desc" => "Upload a logo for your theme, or specify the image address of your online logo. (http://yoursite.com/logo.png)",
                                        "id" => $shortname."_logo",
                                        "std" => "",
                                        "type" => "upload");                                                     
                                        
$options[] = array(	"name" => "Feedburner Integration",
					                "desc" => "Enter your feedburner or alternative RSS here.",
					                "id" => $shortname."_feedburner_url",
					                "std" => "",
					                "type" => "text");      
                                    
$options[] = array( "name" => "Custom CSS",
                                    "desc" => "Quickly add some CSS to your theme by adding it to this block.",
                                    "id" => $shortname."_custom_css",
                                    "std" => "",
                                    "type" => "textarea");
                                    
/*
=================================
         Design Options
=================================
*/

$options[] = array(    "name" => "Design Options","class" => "style",
                                    "type" => "heading"); 

$options[] = array(    "name" => "Theme Design",
                                        "desc" => "Select a base design for your nav and content containers.",
                                        "id" => $shortname."_alt_stylesheet",
                                        "std" => "default-rounded.css",
                                        "type" => "select",
                                        "options" => $alt_stylesheets);
                                        
$options[] = array(    "name" => "Theme Style",
                                        "desc" => "Select a base stylesheet for your theme to use.",
                                        "id" => $shortname."_alt_colorsheet",
                                        "std" => "default.css",
                                        "type" => "select",
                                        "options" => $alt_colorsheets);
                                        
$options[] = array(    "name" => "Background Image",
                                        "desc" => "Upload a background image for the theme, or specify the image address. (eg. http://yoursite.com/logo.png)",
                                        "id" => $shortname."_background_image",
                                        "std" => "",
                                        "type" => "upload");
                                        
$options[] = array(    "name" => "Background Image Position",
                                        "desc" => "Set how your background image will be positioned and how it will repeat.",
                                        "id" => $shortname."_background_position",
                                        "std" => "Center the image at the top of the page",
                                        "type" => "select",
                                        "options" => $background_image_options);

/*
===========================================
Color Options
===========================================
*/
   
$options[] = array(    "name" => "Color Options","class" => "colors",
                                    "type" => "heading");
                                        
$options[] = array( "name" => "Background Color",
                                    "desc" => "Use the color picker or enter a hex value to change the background color of your site.",
                                    "id" => $shortname."_background_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Text Color",
                                    "desc" => "Use the color picker or enter a hex value to set a general text color for your site.",
                                    "id" => $shortname."_text_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Heading Color",
                                    "desc" => "Use the color picker or enter a hex value to set a general heading color for your site.",
                                    "id" => $shortname."_heading_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Link Color",
                                    "desc" => "Use the color picker or enter a hex value to set a general link color for your site.",
                                    "id" => $shortname."_link_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Nav Text Color",
                                    "desc" => "Use the color picker or enter a hex value for your Navigation text.",
                                    "id" => $shortname."_nav_text_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Nav Hover Color",
                                    "desc" => "Use the color picker or enter a hex value to set a background color for your nav items when you hover over them.",
                                    "id" => $shortname."_nav_hover_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Border Color",
                                    "desc" => "Use the color picker or enter a hex value to set a general border color for your site.",
                                    "id" => $shortname."_border_color",
                                    "std" => "",
                                    "type" => "color");

$options[] = array( "name" => "Featured Background Color",
                                    "desc" => "Use the color picker or enter a hex value to set a background color for your featured section.",
                                    "id" => $shortname."_featured_background_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Gridview Background Color",
                                    "desc" => "Use the color picker or enter a hex value to set a background color for your gridview items.",
                                    "id" => $shortname."_gridview_background_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Gridview Title Text Color",
                                    "desc" => "Use the color picker or enter a hex value to set a color for your gridview title text.",
                                    "id" => $shortname."_gridview_text_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Carousel Border Color",
                                    "desc" => "Use the color picker or enter a hex value to set a border color for your carousel items.",
                                    "id" => $shortname."_carousel_border_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Image Border Color",
                                    "desc" => "Use the color picker or enter a hex value to set a border color for your images.",
                                    "id" => $shortname."_image_border_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => " Footer Text Color",
                                    "desc" => "Use the color picker or enter a hex value to set the text color for your footer.",
                                    "id" => $shortname."_footer_text_color",
                                    "std" => "",
                                    "type" => "color");
                                    
$options[] = array( "name" => "Footer Link Color",
                                    "desc" => "Use the color picker or enter a hex value to set the link color for your footer.",
                                    "id" => $shortname."_footer_link_color",
                                    "std" => "",
                                    "type" => "color");

      
/*
=================================
		Navigation Options
=================================
*/

                    
$options[] = array(    "name" => "Navigation Options","class" => "navigation",
                                    "type" => "heading");    

$options[] = array( "name" => "Exclude Pages from Navigation",
                                    "desc" => "If you prefer not to use the Wordpress Custom Menu feature, the navigation will by default show a link to your homepage, followed by links to all of your pages.  In this case, you can enter a comma-separated list of page id's here to exclude from your navigation. (e.g. 12,23,27,44)",
                                    "id" => $shortname."_nav_exclude",
                                    "std" => "",
                                    "type" => "text");
                                    
$options[] = array(    "name" => "Navigation Dropbox",
                                        "desc" => "Select what you want to show in the dropbox on the right side of the navigation bar. (You need to enter a Feedburner address under 'General Settings' if you want a mail icon to appear.",
                                        "id" => $shortname."_nav_right_side",
                                        "std" => "Show a Searchbox",
                                        "type" => "select",
                                        "options" => $nav_right_side_options);
                                    
					
/*
======================
Blog
======================
*/

$options[] = array( "name" => "Blog Settings","class" => "blog",
					"type" => "heading");
					
$options[] = array( "name" => "Blog Layout",
					"desc" => "Select which page layout you would like for your blog.",
					"id" => $shortname."_blog_layout",
					"type" => "select",
					"std" => "Right Sidebar",
                    "options" => array("Right Sidebar", "Left Sidebar", "3 Column", "Full Width") );
                    
$options[] = array( "name" => "Blog Entry Content",
					"desc" => "Choose to show either the full post or an excerpt from each entry on the main blog page.",
					"id" => $shortname."_blog_content",
					"type" => "select",
					"options" => array("Full Post" => "Full Post", "Excerpt" => "Excerpt") );
					
$options[] = array( "name" => "Blog Thumbnail Height",
					"desc" => "You can set your blog thumbnail image height here in pixels.  If this area is left blank, a default image height of 125px is used.",
					"id" => $shortname."_blog_image_height",
					"std" => "",
					"type" => "text");
					
$options[] = array( "name" => "Blog Thumbnail Width",
					"desc" => "You can set your blog thumbnail image width here in pixels.  If this area is left blank, a default image width of 125px is used.",
					"id" => $shortname."_blog_image_width",
					"std" => "",
					"type" => "text");
					
$options[] = array( "name" => "Featured Image Height",
					"desc" => "You can set your blog thumbnail image height here in pixels.  If this area is left blank, a default image height of 125px is used.",
					"id" => $shortname."_featured_image_height",
					"std" => "",
					"type" => "text");
					
$options[] = array( "name" => "Featured Image Width",
					"desc" => "You can set your blog thumbnail image width here in pixels.  If this area is left blank, a default image width of 125px is used.",
					"id" => $shortname."_featured_image_width",
					"std" => "",
					"type" => "text");
					
/*
=================================
		Shop Settings
=================================
*/
                  
$options[] = array(        "name" => "Shop Settings","class" => "shop",
                                       "type" => "heading");
                                        
$options[] = array( "name" => "Default Product Page Layout",
					"desc" => "Select which page layout you would like for your default products page. This will also affect your 'My Account', 'Transaction Results' and 'Checkout' pages",
					"id" => $shortname."_shop_layout",
					"type" => "select",
					"std" => "Right Sidebar",
                    "options" => array("Right Sidebar", "Left Sidebar", "3 Column", "Full Width") );
                    
$options[] = array( "name" => "Single Product Page Layout",
					"desc" => "Select which page layout you would like for your single product page.",
					"id" => $shortname."_shop_single_layout",
					"type" => "select",
					"std" => "Right Sidebar",
                    "options" => array("Right Sidebar", "Left Sidebar", "3 Column", "Full Width") );
                                        
$options[] = array( "name" => "Shorten Product Description in List View?",
                    "desc" => "If checked, this option will show only a portion of the product description when looking at a group of products in list view.  Full product description will be shown on individual product pages.",
                    "id" => $shortname."_shorten_product_descriptions",
                    "std" => "true",
                    "type" => "checkbox");
                                        
$options[] = array( "name" => "Use Storefront Gridview?",
					"desc" => "Check this if you want to use the built-in gridview for your product pages. <strong>NOTE: You must have the 'Storefront Products' page template selected for your product page in order for this to work.</strong>",
					"id" => $shortname."_gridview",
					"std" => "true",
					"type" => "checkbox");
					
$options[] = array( "name" => "Show Titles in Gridview?",
					"desc" => "Check this if you want to show the product title in your gridview. Leave it unchecked if you want to just show the image. <strong>NOTE: You must have the Storefront Gridview button checked above in order for this to work.</strong>",
					"id" => $shortname."_gridview_title",
					"std" => "true",
					"type" => "checkbox");
					
$options[] = array(    "name" => "Product Image Link",
					"desc" => "On the default product page, choose whether the product image should link to the product or the full size image. Single Product page images will always link to the full size image.",
					"id" => $shortname."_product_image_link",
					"std" => "product",
					"type" => "select",
					"options" => array("product","image"));

                                        
                                        
/*
=================================
		Homepage Featured
=================================
*/

                                                            
$options[] = array(    "name" => "Homepage Featured","class" => "homepage",
                                        "type" => "heading");

// ============== Featured Post Slider ==============                                      
$options[] = array(    "name" => "Featured Display Options",
                                        "desc" => "Select what you want to display in your featured area.",
                                        "id" => $shortname."_featured_display_options",
                                        "std" => "Show Blog Posts",
                                        "type" => "select",
                                        "options" => $featured_display_options);
                                        
$options[] = array(    "name" => "Featured Static Image",
                                        "desc" => "If you chose to show a static image in the featured area, upload an image here, or specify the image address. (eg. http://yoursite.com/image.png).  Size will be adjusted to 920px x 290px.",
                                        "id" => $shortname."_featured_image",
                                        "std" => "",
                                        "type" => "upload");
                                        
$options[] = array( "name" => "Custom HTML",
                                    "desc" => "If you chose to code your own html in the featured area, put that code here.",
                                    "id" => $shortname."_featured_html",
                                    "std" => "",
                                    "type" => "textarea");                      

$options[] = array( "name" => "Blog Category",
                                    "desc" => "If you are showing blog posts, you can select the post category to use for your featured slider.",
                                    "id" => $shortname."_featured_cat",
									"std" => "All categories",
									"type" => "select",
									"options" => $storefront_categories);
                                    
$options[] = array(    "name" => "Number of Blog Posts",
                                        "desc" => "If you are showing blog posts, you can select the number of posts to display in your featured slider.",
                                        "id" => $shortname."_featured_posts",
                                        "std" => "Select a number:",
                                        "type" => "select",
                                        "options" => $other_entries);
                                        
$options[] = array(    "name" => "Featured Speed",
                                        "desc" => "Select the number of seconds to pause between each slide of the featured slider/rotator.",
                                        "id" => $shortname."_featured_speed",
                                        "std" => "5",
                                        "type" => "select",
                                        "options" => $featured_speed);
                                        
$options[] = array(    "name" => "Featured Transition Speed",
                                        "desc" => "Set the transition speed for the slider/rotator.  The number is in tenths of a second, so '10' would be one second.",
                                        "id" => $shortname."_featured_trans_speed",
                                        "std" => "7",
                                        "type" => "select",
                                        "options" => $featured_trans_speed);


/*
=================================
		Homepage Carousel
=================================
*/

                                                            
$options[] = array(    "name" => "Homepage Carousel","class" => "homepage",
                                        "type" => "heading");

                                                                       
                                        
$options[] = array(    "name" => "Carousel Options",
                                        "desc" => "Specify what to show in the carousel div.",
                                        "id" => $shortname."_carousel_option",
                                        "std" => "Don't use the carousel div",
                                        "type" => "select",
                                        "options" => $homepage_carousel);
/*                                        
$options[] = array( "name" => "Maximum Number of Carousel Items",
                                    "desc" => "If you would like to limit the number of blog posts that appear in the carousel, enter your maximum number here. (eg. 12, 18, 24, etc)<br /><strong>NOTE: This will not work when showing products or product categories.  The product limit per page is set under your WP E-Commerce options and all product categories will be shown regardless of the number set here.</strong>",
                                    "id" => $shortname."_carousel_post_limit",
                                    "std" => "18",
                                    "type" => "text");*/
                                    
$options[] = array(	"name" => "Carousel Post Category",
					"desc" => "If you are showing posts in your carousel, select a post category to pull your posts from.",
					"id" => $shortname."_carousel_post_category",
					"std" => "All categories",
					"type" => "select",
					"options" => $storefront_categories);

$options[] = array(	"name" => "Carousel Product Category",
					"desc" => "If you are showing products in your carousel, you can select to show all products or products from a specific category.",
					"id" => $shortname."_carousel_prod_category",
					"std" => "Select a category:",
					"type" => "select",
					"options" => $storefront_shop_categories);
                                    
$options[] = array(    "name" => "Autoscroll the Carousel?",
                                        "desc" => "If checked, the carousel will auto scroll, pausing the number of seconds indicated below.",
                                        "id" => $shortname."_carousel_autoscroll",
                                        "std" => "true",
                                        "type" => "checkbox");
                                    
$options[] = array(    "name" => "Carousel Autoscroll-Speed",
                                        "desc" => "Select the number of seconds to pause before scrolling the carousel.",
                                        "id" => $shortname."_carousel_speed",
                                        "std" => "15",
                                        "type" => "select",
                                        "options" => $numbers_only);
                                        
$options[] = array( "name" => "Maximum Number of Carousel Items",
                                    "desc" => "If you would like to limit the number of items that appear in the carousel, enter your maximum number here. (eg. 4, 8, 12, etc)<br /><strong>NOTE: This will not work when showing products or product categories.  To show all products, use '-1'</strong>",
                                    "id" => $shortname."_carousel_post_limit",
                                    "std" => "",
                                    "type" => "text");


/*
=================================
		Homepage Gridview
=================================
*/

                                                            
$options[] = array(    "name" => "Homepage Gridview","class" => "homepage",
                                        "type" => "heading");
                                                                                 
                                                                                
$options[] = array( "name" => "Gridview Title",
                                    "desc" => "If you would like a heading to appear above your gridview, please enter it here.",
                                    "id" => $shortname."_gridview_heading",
                                    "std" => "",
                                    "type" => "textarea");
                                    
$options[] = array(    "name" => "Gridview Options",
                                        "desc" => "Specify what to show in the gridview div.",
                                        "id" => $shortname."_gridview_option",
                                        "std" => "Don't use the gridview div",
                                        "type" => "select",
                                        "options" => $homepage_gridview);
                                        
$options[] = array(	"name" => "Gridview Post Category",
					"desc" => "If you are showing posts in your gridview, select a post category to pull your posts from.",
					"id" => $shortname."_gridview_post_category",
					"std" => "All categories",
					"type" => "select",
					"options" => $storefront_categories);
					
$options[] = array(	"name" => "Carousel Product Category",
					"desc" => "If you are showing products in your carousel, you can select to show only products from a specific category here.  The number of products you can show in the carousel is limited to the number of products you can view on your products page.<br /><strong>NOTE:  If you select to show all products, you must also select this under 'Product Page Settings' in your Store Presentation Settings.</strong>",
					"id" => $shortname."_gridview_prod_category",
					"std" => "Select a category:",
					"type" => "select",
					"options" => $storefront_shop_categories);
					
$options[] = array(	"name" => "Carousel Category Group",
					"desc" => "If you are showing product categories in your carousel, you choose which group of categories to show here.<br /><strong>NOTE: This will show top-level categories only.</strong>",
					"id" => $shortname."_gridview_cat_group",
					"std" => "All",
					"type" => "radio",
					"options" => $storefront_shop_groups);
                                        
$options[] = array(    "name" => "Show Title In Gridview?",
                                        "desc" => "If checked, the product, category or post title will appear below the image.",
                                        "id" => $shortname."_gridview_show_title",
                                        "std" => "true",
                                        "type" => "checkbox");
                                        
$options[] = array( "name" => "Maximum Number of Gridview Posts",
                                    "desc" => "If you would like to limit the number of blog posts that appear in the gridview, enter your maximum number here. (eg. 4, 8, 12, etc)<br /><strong>NOTE: This will not work when showing products or product categories.  The product limit per page is set under your WP E-Commerce options and all product categories will be shown regardless of the number set here.</strong>",
                                    "id" => $shortname."_gridview_post_limit",
                                    "std" => "",
                                    "type" => "text");
                                    
$options[] = array( "name" => "Gridview Image Height",
                                    "desc" => "While the width of each image in the gridview is set at 200px, you can specify the image height here in pixels.  The default height is 200px.",
                                    "id" => $shortname."_gridview_image_height",
                                    "std" => "200",
                                    "type" => "text");
      
  
  
/*
=================================
		Footer Options
=================================
*/

$options[] = array(	"name" => "Footer Options","class" => "footer",
					"type" => "heading");

$options[] = array(	"name" => "Footer Left",
					"desc" => "Enter some text or html to appear in the left side of the footer.",
					"id" => $shortname."_footer_left",
					"std" => "",
					"type" => "textarea");
					
$options[] = array(	"name" => "Footer Right",
					"desc" => "Enter some text or html to appear in the right side of the footer.",
					"id" => $shortname."_footer_right",
					"std" => "",
					"type" => "textarea");
					
/*
======================
Analytics & SEO
======================
*/ 

$options[] = array( "name" => "Analytics & SEO","class" => "analytics",
                    "type" => "heading"); 
                                               
$options[] = array( "name" => "Analytics - Tracking Code",
					"desc" => "Paste your Google Analytics (or other) tracking code here. This will be added into the footer template of your theme.",
					"id" => $shortname."_google_analytics",
					"std" => "",
					"type" => "textarea");
					
$options[] = array(    "name" => "SEO - Activate Meta Functionality?",
                                        "desc" => "If checked, this option will allow the meta options below to be activated.  By default, this is turned off as it works with most server setups, but not all.  A select few may not be able to use this functionality.",
                                        "id" => $shortname."_meta",
                                        "std" => "false",
                                        "type" => "checkbox");
                    
$options[] = array(    "name" => "SEO - Show a Meta Description?",
                                        "desc" => "If checked, this option will allow a meta description to be place in the 'head' of your pages.  The default will be the site slogan.  The homepage can be customized below.  Product descriptions will be used for single product pages.  Category descriptions will be used for product category pages.  You can customize this for individual posts and pages using the custom settings at the bottom of the page edit screen.",
                                        "id" => $shortname."_show_meta_description",
                                        "std" => "false",
                                        "type" => "checkbox");
                                        
$options[] = array(    "name" => "SEO - Show Meta Keywords?",
                                        "desc" => "If checked, this option will allow meta keywords to be place in the 'head' of your single product pages.  The default will be the home keywords below.  You can customize this for individual posts and pages using the custom settings at the bottom of the page edit screen.  Products and Categories do not have keywords.",
                                        "id" => $shortname."_show_meta_keywords",
                                        "std" => "false",
                                        "type" => "checkbox");
                                        
$options[] = array(    "name" => "SEO - Homepage Meta Description",
                                        "desc" => "Enter your home page description here.",
                                        "id" => $shortname."_homepage_meta_description",
                                        "std" => "",
                                        "type" => "textarea"); 
                                        
$options[] = array(    "name" => "SEO - Homepage Meta Keywords",
                                        "desc" => "Enter your home page keywords here, separated by commas.",
                                        "id" => $shortname."_homepage_meta_keywords",
                                        "std" => "",
                                        "type" => "textarea"); 
                                  
/*
=================================
		CUSTOM POST OPTIONS
=================================
*/                                                                            


$storefront_metaboxes = array(

		"Meta Description" => array (
			"name"		=> "meta-description",
			"default" 	=> "",
			"label" 	=> "Meta Description",
			"type" 		=> "textarea",
			"desc"      => "Text that is entered here will be placed in a meta description tag."
		),
		"Meta Keywords" => array (
			"name"		=> "meta-keywords",
			"default" 	=> "",
			"label" 	=> "Meta Keywords",
			"type" 		=> "text",
			"desc"      => "Text that is entered here will be placed in a meta keywords tag (Separate keywords by commas)."
		),				
    );
    
                        
        update_option('storefront_template',$options);
        update_option('storefront_themename',$themename);      
        update_option('storefront_shortname',$shortname ); 
        update_option('storefront_manual',$manualurl ); 
        
update_option('storefront_custom_template',$storefront_metaboxes);
 
 
    
}

add_action('init','storefront_options')
 
?>